# This file was created automatically by SWIG.
import materialsubproblemc
from oof2.SWIG.engine.csubproblem import CSubProblemPtr
from oof2.SWIG.common.lock import LockPtr
class MaterialSubProblemPtr(CSubProblemPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __setattr__(self,name,value):
        if name == "precomputeLock" :
            materialsubproblemc.MaterialSubProblem_precomputeLock_set(self,value.this)
            return
        if name == "precomputeRequired" :
            materialsubproblemc.MaterialSubProblem_precomputeRequired_set(self,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "precomputeLock" : 
            return LockPtr(materialsubproblemc.MaterialSubProblem_precomputeLock_get(self))
        if name == "precomputeRequired" : 
            return materialsubproblemc.MaterialSubProblem_precomputeRequired_get(self)
        raise AttributeError,name
    def __repr__(self):
        return "<C MaterialSubProblem instance at %s>" % (self.this,)
class MaterialSubProblem(MaterialSubProblemPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(materialsubproblemc.new_MaterialSubProblem,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: materialsubproblem.spy,v $
# $Revision: 1.8 $
# $Author: langer $
# $Date: 2007/02/12 19:05:40 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.SWIG.engine import csubproblem
from oof2.common import cregisteredclass
from oof2.common import debug
from oof2.engine import materialmanager
from oof2.engine.IO import materialparameter

# Redefine the MaterialSubProblem init so that it converts the Material
# name to a Material object.

_old_init_ = MaterialSubProblem.__init__
def _MaterialSubProblem___init__(self, material):
    self.material = material            # material name
    _old_init_(self, materialmanager.getMaterial(self.material))

MaterialSubProblem.__init__ = _MaterialSubProblem___init__

def _MaterialSubProblem_getMaterials(self):
    return [materialmanager.getMaterial(self.material)]
    
# MaterialSubProblems need to know if materials have been assigned to
# pixels, so that they can reset their cached lists of nodes, etc.  To
# do this, a MaterialSubProbNotifier object is installed as a
# switchboard callback. 

class MaterialSubProbNotifier:
    def __init__(self, subpctxt):
        self.subpctxt = subpctxt
        param = subpctxt.getObject().getRegistration().getParameter('material')
        self.material = param.value
    def __call__(self, microstructure):
        ## switchboard callback for "materials changed in microstructure"
        if self.subpctxt.getMicrostructure().name() == microstructure.name():
            self.subpctxt.redefined()

def _startup(subpctxt):
    subpctxt.requestCallback("materials changed in microstructure",
                             MaterialSubProbNotifier(subpctxt))

##############

cregisteredclass.Registration(
    "Material",
    csubproblem.CSubProblemPtr,
    MaterialSubProblem,
    ordering=2,
    params=[materialparameter.MeshMaterialParameter('material',
                                         tip="Use elements with this Material")
    ],
    startup=_startup,
    tip="A subproblem defined on all Elements composed of a given Material.",
    discussion="""<para>

    A <classname>MaterialSubProblem</classname> includes all &elems;
    with the given &material; type.  The &material; type of an &elem;
    is the &material; type of the <link linkend="Section:Concepts:Skeleton:Homogeneity">dominant pixel</link> within the &elem;.

    </para>"""
    )
                             
