# This file was created automatically by SWIG.
import timestepadapterc
from oof2.SWIG.engine.steppingscheme import SteppingSchemePtr
from oof2.SWIG.engine.solverdriver import SolverDriverCorePtr
class TimeStepAdapterPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,timestepadapterc=timestepadapterc):
        if self.thisown == 1 :
            timestepadapterc.delete_TimeStepAdapter(self)
    def keep_going(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_keep_going,(self,) + _args, _kwargs)
        return val
    def get_dt(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_get_dt,(self,) + _args, _kwargs)
        return val
    def set_time_step(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_set_time_step,(self,) + _args, _kwargs)
        return val
    def get_residual(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_get_residual,(self,) + _args, _kwargs)
        return val
    def accept(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_accept,(self,) + _args, _kwargs)
        return val
    def reject(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_reject,(self,) + _args, _kwargs)
        return val
    def get_tolerance(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_get_tolerance,(self,) + _args, _kwargs)
        return val
    def is_okay(self, *_args, **_kwargs):
        val = apply(timestepadapterc.TimeStepAdapter_is_okay,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C TimeStepAdapter instance at %s>" % (self.this,)
class TimeStepAdapter(TimeStepAdapterPtr):
    def __init__(self,this):
        self.this = this




class NullAdapterPtr(TimeStepAdapterPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,timestepadapterc=timestepadapterc):
        if self.thisown == 1 :
            timestepadapterc.delete_NullAdapter(self)
    def __repr__(self):
        return "<C NullAdapter instance at %s>" % (self.this,)
class NullAdapter(NullAdapterPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(timestepadapterc.new_NullAdapter,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: timestepadapter.spy,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2007/01/08 18:27:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import cregisteredclass
from oof2.common import debug
from oof2.common import registeredclass
from oof2.common.IO import parameter
from oof2.common.IO import reporter
from oof2.common.IO import mainmenu
from oof2.common.IO import oofmenu
from oof2.common.IO import xmlmenudump
from oof2.SWIG.common.IO import progressbar

def __get_step_adapter_state(self, subpcontext, steppermethod):
    pbar = progressbar.getProgress()
    steppermethodrequest = (
        pbar.query_stop() > 0 or
        subpcontext.getObject().current_time() >= steppermethod.get_tf())
    ## both the steppermethod or the timestepadapter can request to
    ## stop the process
    return not steppermethodrequest and self.keep_going()
TimeStepAdapterPtr.get_step_adapter_state = __get_step_adapter_state

def __TimeStepAdapterIterate(self, subpcontext, steppermethod):
    
    timestepadapterstate = self.get_step_adapter_state(subpcontext, steppermethod)
    if timestepadapterstate:
        ## if we are cool, update time-step using previous time step,
        ## global target time, and error.  set dt for all the
        ## steppermethods, if the specific time step adapter requires
        ## it.
        self.set_time_step(subpcontext.getObject(), steppermethod)
    return timestepadapterstate
TimeStepAdapterPtr.iterate = __TimeStepAdapterIterate

def __TimeStepAdapterApplyAdditional(self, solverdriver, subpcontext,
                                       verbosity = 1, report_success = 1):
    ## default is PASS
    ## subclasses may have other trial solutions to compare against
    ## (interpolations, extrapolations, etc.) which may require to
    ## apply the SAME solverdriver
    pass
TimeStepAdapterPtr.apply_additional_methods = __TimeStepAdapterApplyAdditional

def __TimeStepAdapterApply(self, steppermethod, solverdriver, subpcontext,
                             verbosity = 1, report_success = 1):
        ## solver is applied (maybe more than once), BUT solution is not
    ## accepted yet.
    solverdriver.apply(steppermethod, subpcontext, verbosity)
    self.apply_additional_methods(solverdriver, subpcontext, verbosity,
                                  report_success) ## DEFAULT IS PASS
TimeStepAdapterPtr.apply = __TimeStepAdapterApply

def __TimeStepAdapterUpdate(self, subpcontext, steppermethod):
    residual = self.get_residual(steppermethod)
    ## each stepper adapter returns a residual.
    ## the default is zero.

    ## if residual is within bounds, then accept the solution
    ## otherwise restore the initial state (solution), and adjust the
    ## time step adapter's internal machinery (e.g., time-step)
    ## to try again or bail out from the loop.
    if residual <= self.get_tolerance():
        ## accept solution:
        ## update internal machinery of stepadapter
        ## and current time index
        self.accept(subpcontext.getObject(), steppermethod)
        reporter.report("time index = %g" %
                        subpcontext.getObject().current_time())
    else:
        ## try again:
        ## trash trial solution
        ## restore solution in mesh
        self.reject(subpcontext.getObject())
TimeStepAdapterPtr.update = __TimeStepAdapterUpdate

cregisteredclass.registerCClass(TimeStepAdapterPtr)

TimeStepAdapterPtr.tip = "Methods for dynamically adapting the time-step time-dependent problems."

cregisteredclass.Registration(
    'NullAdapter',
    TimeStepAdapterPtr, ## base class
    NullAdapter, ## subclass
    ordering=100,
    params = [],
    tip = "no time adaptation"
    )

