// -*- C++ -*-
// $RCSfile: abstractimage.h,v $
// $Revision: 1.1 $
// $Author: langer $
// $Date: 2006/10/10 01:14:06 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef ABSTRACTIMAGE_H
#define ABSTRACTIMAGE_H

class Coord;
class ICoord;
class StringImage;
class AlphaStringImage;

class AbstractImage {
public:
  virtual ~AbstractImage() {}
  virtual const Coord &size() const = 0;
  virtual const ICoord &sizeInPixels() const = 0;
  virtual void fillstringimage(StringImage*) const {};
  virtual void fillalphastringimage(AlphaStringImage*, unsigned char) const {};
};

#endif // ABSTRACTIMAGE_H
