# -*- python -*- 
# $RCSfile: DIR.py,v $
# $Revision: 1.36 $
# $Author: langer $
# $Date: 2007/02/26 20:51:36 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modifed
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

dirname = ['engine']
clib = 'oof2engine'
clib_order = 1
subdirs = ['property', 'elements', 'SparseLib++', 'IO']

if HAVE_PETSC:
    print "PETSC subdirectory appended"
    subdirs.append('PETSc')


cfiles = ['bdyanalysis.C', 'blockpre_double.C', 'boundarycond.C',
'cconjugate.C', 'celectricfield.C', 'compoundsubproblem.C',
'contourcell.C', 'cscpatch.C', 'cskeleton.C', 'csrmatrix.C',
'cstrain.C', 'csubproblem.C', 'edge.C', 'edgeset.C', 'eigenvalues.C',
'element.C', 'elementnodeiterator.C', 'equation.C', 'eulerangle.C',
'field.C', 'femesh.C', 'fieldeqnlist.C', 'fieldindex.C', 'flux.C',
'fluxnormal.C', 'freedom.C', 'gausspoint.C', 'invariant.C',
'linearizedsystem.C', 'log_value.C', 'mastercoord.C',
'masterelement.C', 'material.C', 'materialsubproblem.C',
'meshiterator.C', 'mvmult.C', 'nodalequation.C', 'nodalfluxes.C',
'nodalscpatches.C', 'node.C', 'ooferror.C', 'outputval.C',
'pixelgroupsubproblem.C', 'pixelintersection.C',
'pixelselectioncouriere.C', 'preconditioner.C', 'property.C',
'pypropertywrapper.C', 'rank3tensor.C', 'recoveredflux.C',
'shapefunction.C', 'shapefunctioncache.C', 'smallmatrix.C',
'solver.C', 'solverdriver.C', 'steppingscheme.C', 'symeig3.C',
'symmmatrix.C', 'timederivative.C', 'timestepadapter.C',
'timestepadaptermanager.C', 'twomatrix.C', 'entiremeshsubproblem.C']

swigfiles = ['bdyanalysis.swg', 'boundarycond.swg', 'cconjugate.swg',
'compoundsubproblem.swg', 'contourcell.swg', 'cskeleton.swg',
'csrmatrix.swg', 'cstrain.swg', 'csubproblem.swg', 'edge.swg',
'edgeset.swg', 'element.swg', 'elementnodeiterator.swg',
'equation.swg', 'eulerangle.swg', 'femesh.swg', 'field.swg',
'fieldindex.swg', 'flux.swg', 'freedom.swg', 'gausspoint.swg',
'invariant.swg', 'linearizedsystem.swg', 'mastercoord.swg',
'masterelement.swg', 'material.swg', 'materialsubproblem.swg',
'meshiterator.swg', 'nodalequation.swg', 'node.swg', 'ooferror2.swg',
'outputval.swg', 'pixelgroupsubproblem.swg',
'pixelselectioncouriere.swg', 'planarity.swg', 'preconditioner.swg',
'properties.swg', 'pypropertywrapper.swg', 'rank3tensor.swg',
'smallmatrix.swg', 'solver.swg', 'solverdriver.swg', 'sparselink.swg',
'steppingscheme.swg', 'symmmatrix.swg', 'timederivative.swg',
'timestepadapter.swg', 'timestepadaptermanager.swg',
'entiremeshsubproblem.swg', 'vector.swg']

pyfiles = ['adaptivemeshrefinement.py', 'analysisdomain.py',
'analysissample.py', 'anneal.py', 'autoskeleton.py',
'bdycondition.py', 'boundary.py', 'boundarybuilder.py',
'boundarymodifier.py', 'builtinprops.py', 'component.py',
'conjugate.py', 'deputy.py', 'deputytracker.py', 'edgeswap.py',
'errorestimator.py', 'fiddlenodesbase.py', 'fieldinit.py',
'initialize.py', 'instantnodemove.py', 'interface_criteria.py',
'materialmanager.py', 'materialplugin.py', 'mergetriangles.py',
'mesh.py', 'meshbdyanalysis.py', 'meshcrosssection.py', 'meshmod.py',
'pinnodesmodifier.py', 'pixelselect.py', 'problem.py',
'problemmanager.py', 'profile.py', 'profilefunction.py',
'propertyregistration.py', 'pyproperty.py', 'rationalize.py',
'rationalizefunctions.py', 'rationalsharp.py', 'rationalshort.py',
'rationalwide.py', 'refine.py', 'refinementtarget.py',
'refinemethod.py', 'refinequadbisection.py', 'relaxation.py',
'revertmesh.py', 'scpatch.py', 'skeleton.py', 'skeletonboundary.py',
'skeletoncontext.py', 'skeletondiff.py', 'skeletonelement.py',
'skeletongroups.py', 'skeletonmodifier.py', 'skeletonnode.py',
'skeletonsegment.py', 'skeletonselectable.py',
'skeletonselectionmethod.py', 'skeletonselectionmod.py',
'skeletonselectionmodes.py', 'skeletonselmodebase.py', 'snapnode.py',
'snaprefine.py', 'snaprefinemethod.py', 'splitquads.py',
'subproblemcontext.py', 'symstate.py', 'timedrivers.py',
'vigilante.py']

swigpyfiles = ['compoundsubproblem.spy', 'contourcell.spy',
'csrmatrix.spy', 'cstrain.spy', 'csubproblem.spy', 'edge.spy',
'edgeset.spy', 'element.spy', 'elementnodeiterator.spy',
'equation.spy', 'eulerangle.spy', 'femesh.spy', 'field.spy',
'fieldindex.spy', 'flux.spy', 'invariant.spy', 'linearizedsystem.spy',
'mastercoord.spy', 'masterelement.spy', 'material.spy',
'materialsubproblem.spy', 'node.spy', 'ooferror2.spy',
'outputval.spy', 'pixelgroupsubproblem.spy', 'preconditioner.spy',
'property.spy', 'pypropertywrapper.spy', 'rank3tensor.spy',
'smallmatrix.spy', 'solver.spy', 'solverdriver.spy', 'sparselink.spy',
'steppingscheme.spy', 'symmmatrix.spy', 'timestepadapter.spy',
'timestepadapter.spy', 'timestepadaptermanager.spy',
'entiremeshsubproblem.spy', 'vector.spy']

hfiles = ['automatrix.h', 'bdyanalysis.h', 'blockpre_double.h',
'boundarycond.h', 'cconjugate.h', 'celectricfield.h',
'compoundsubproblem.h', 'constraint.h', 'contourcell.h', 'cscpatch.h',
'cskeleton.h', 'csrmatrix.h', 'cstrain.h', 'csubproblem.h', 'edge.h',
'edgeset.h', 'eigenvalues.h', 'element.h', 'elementnodeiterator.h',
'equation.h', 'eulerangle.h', 'femesh.h', 'field.h', 'fieldeqnlist.h',
'fieldindex.h', 'flux.h', 'fluxnormal.h', 'freedom.h', 'gausspoint.h',
'group.h', 'indextypes.h', 'invariant.h', 'linearizedsystem.h',
'log_value.h', 'mastercoord.h', 'masterelement.h', 'material.h',
'materialsubproblem.h', 'matrixbase.h', 'matvec.h', 'meshiterator.h',
'mvmult.h', 'nodalequation.h', 'nodalfluxes.h', 'nodalscpatches.h',
'node.h', 'nodegroup.h', 'ooferror.h', 'outputval.h',
'pixelgroupsubproblem.h', 'pixelselectioncouriere.h', 'planarity.h',
'preconditioner.h', 'predicatesubproblem.h', 'property.h',
'pypropertywrapper.h', 'rank3tensor.h', 'recoveredflux.h',
'shapefunction.h', 'shapefunctioncache.h', 'smallmatrix.h',
'solver.h', 'solverdriver.h', 'sparselink.h', 'steppingscheme.h',
'symeig3.h', 'symmmatrix.h', 'timederivative.h', 'timestepadapter.h',
'timestepadaptermanager.h', 'twomatrix.h', 'twovector.h',
'entiremeshsubproblem.h']

def set_clib_flags(clib):
    clib.externalLibs.append('oof2common')


if HAVE_MPI:
    cfiles.extend(['cfiddlenodesbaseParallel.C'])
    swigfiles.extend(['cfiddlenodesbaseParallel.swg'])
    swigpyfiles.extend(['cfiddlenodesbaseParallel.spy'])
    hfiles.extend(['cfiddlenodesbaseParallel.h'])
    pyfiles.extend(['fiddlenodesbaseParallel.py', 'refineParallel.py'])


